"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isAffineMatrix = isAffineMatrix;

var _utils = require("./utils");

/**
 * Check if the object contain an affine matrix
 * @param object {Object} Generic Plain Object
 * @return {boolean} True if is an object and contains an affine matrix
 */
function isAffineMatrix(object) {
  return (0, _utils.isObject)(object) && object.hasOwnProperty('a') && (0, _utils.isNumeric)(object.a) && object.hasOwnProperty('b') && (0, _utils.isNumeric)(object.b) && object.hasOwnProperty('c') && (0, _utils.isNumeric)(object.c) && object.hasOwnProperty('d') && (0, _utils.isNumeric)(object.d) && object.hasOwnProperty('e') && (0, _utils.isNumeric)(object.e) && object.hasOwnProperty('f') && (0, _utils.isNumeric)(object.f);
}