"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.scale = scale;

var _utils = require("./utils");

/**
 * Calculate a scaling matrix
 * @param sx {number} Scaling on axis x
 * @param [sy = sx] {number} Scaling on axis y (default sx)
 * @returns {Matrix} Affine Matrix
 */
function scale(sx, sy = undefined) {
  if ((0, _utils.isUndefined)(sy)) sy = sx;
  return {
    a: sx,
    c: 0,
    e: 0,
    b: 0,
    d: sy,
    f: 0
  };
}