import React from "react";
import {
  fitSelection,
  fitToViewer,
  INITIAL_VALUE,
  ReactSVGPanZoom,
  TOOL_NONE,
  zoomOnViewerCenter
} from "react-svg-pan-zoom";
import { AutoSizer } from "react-virtualized";
// import { ReactSvgPanZoomLoader } from "react-svg-pan-zoom-loader";

// import "./SVG.scss";

class svg extends React.Component {
  //   constructor(props) {
  //     super(props);
  //   }
  state = { tool: TOOL_NONE, value: INITIAL_VALUE };
  Viewer = null;
  changeTool(nextTool) {
    this.setState({ tool: nextTool });
  }

  changeValue(nextValue) {
    this.setState({ value: nextValue });
  }

  fitToViewer() {
    this.setState(state => ({ value: fitToViewer(state.value) }));
  }

  fitSelection() {
    this.setState(state => ({
      value: fitSelection(state.value, 40, 40, 200, 200)
    }));
  }

  zoomOnViewerCenter() {
    this.setState(state => ({ value: zoomOnViewerCenter(state.value, 1.1) }));
  }

  render() {
    var img = this.props.svgFile;
    return (
      <div style={{ width: "100%", height: "100%" }}>
        <AutoSizer>
          {({ width, height }) =>
            width === 0 || height === 0 ? null : (
              <ReactSVGPanZoom
                width={width}
                height={height}
                // toolbarProps={position => "botton"}
                ref={Viewer => (this.Viewer = Viewer)}
                tool={this.state.tool}
                onChangeTool={tool => this.changeTool(tool)}
                value={this.state.value}
                onChangeValue={value => this.changeValue(value)}
                // onClick={event =>
                //   console.log(
                //     "click",
                //     event.x,
                //     event.y,
                //     event.originalEvent
                //   )
                // }
              >
                <svg width={this.props.widthsvg} height={this.props.hightsvg}>
                  {/* You can replace the following line with a safer way to load SVG */}
                  <g dangerouslySetInnerHTML={{ __html: img }} />
                </svg>
              </ReactSVGPanZoom>
            )
          }
        </AutoSizer>
      </div>
    );
  }
}

export default svg;
